/**
 * ol-games - Game stuff for ol, powered by HTML5, canvas, javascript and Openlayers.
 * @description ol,openlayers,ol-ext,gamer,gameloop,animation,sprite,media,audio
 * @version v1.0.1
 * @author Jean-Marc Viglino
 * @see https://github.com/Viglino/ol-games
 * @license BSD-3-Clause
 */
ol.control.FrameRate=function(t){var e=t||{},i=ol.ext.element.create("DIV",{className:(e.className||"ol-framerate")+(e.target?"":" ol-unselectable ol-control")}),o=this.canvas_=document.createElement("canvas");o.width=100,o.height=40,i.appendChild(o),this.ctx=o.getContext("2d"),this.ctx.font="bold 11px sans-serif",this.ctx.textAlign="center",this.ctx.textBaseline="top",this.ctx.fillStyle="#fff",this.ctx.fillRect(1,15,99,45),ol.control.Control.call(this,{element:i,target:e.target})},ol.inherits(ol.control.FrameRate,ol.control.Control),ol.control.FrameRate.prototype.setMap=function(t){this._listener&&ol.Observable.unByKey(this._listener),this._listener=null,ol.control.Control.prototype.setMap.call(this,t),this.getMap()&&(this._listener=this.getMap().on("precompose",this.update_.bind(this)),this.time_=(new Date).getTime())},ol.control.FrameRate.prototype.update_=function(t){var e=t.frameState.time-this.time;this.time=t.frameState.time,this.ctx.drawImage(this.canvas_,1,15,99,this.canvas_.height,0,15,99,this.canvas_.height);var i=Math.round(500/e);this.ctx.clearRect(0,0,100,15),this.ctx.fillStyle="#000",this.ctx.fillText(2*i+" fps",50,0),this.ctx.strokeStyle="#fff",this.ctx.beginPath(),this.ctx.moveTo(100,15),this.ctx.lineTo(100,40),this.ctx.closePath(),this.ctx.stroke(),this.ctx.strokeStyle=i>20?"#060":i>12?"#f80":"#800",this.ctx.beginPath(),this.ctx.moveTo(100,40-i/2),this.ctx.lineTo(100,40),this.ctx.closePath(),this.ctx.stroke()},Math.sign||(Math.sign=function(t){return(t=Number(t))?t>0?1:-1:t}),Math.trunc||(Math.trunc=function(t){return t<0?Math.ceil(t):Math.floor(t)}),ol.Sprite=function(t){t=t||{},this.coord=new ol.geom.Point(t.position||[0,0]),ol.Feature.call(this,this.coord),this.style=new ol.style.Style({image:new ol.style.Sprite(t),text:new ol.style.Text({font:"bold 12px helvetica,sans-serif",text:t.name||"",offsetY:-(t.size||64)/2*t.scale,textBaseline:"alphabetic",stroke:new ol.style.Stroke({color:[255,255,255,.5],width:5}),fill:new ol.style.Fill({color:"#333"})})}),this.setStyle([this.style]),this.image=this.style.getImage(),this.frate=t.frameRate||100,this.currentState="idle",this.startState=0,this.speed=0,this.dir=[0,0]},ol.ext.inherits(ol.Sprite,ol.Feature),ol.Sprite.prototype.setName=function(t){this.style.getText().setText(t),this.changed()},ol.Sprite.prototype.setCoordinate=function(t){this.coord.setCoordinates(t)},ol.Sprite.prototype.getCoordinate=function(){return this.coord.getCoordinates()},ol.Sprite.prototype.setGeometry=function(t){this.coord=t,ol.Feature.prototype.setGeometry.call(this,t)},ol.Sprite.prototype.getImage=function(){return this.image},ol.Sprite.prototype.setRotation=function(t){this.style.getImage().setRotation(t),this.changed()},ol.Sprite.prototype.getRotation=function(){return this.style.getImage().getRotation()},ol.Sprite.prototype.setScale=function(t){this.style.getImage().setScale(t),this.changed()},ol.Sprite.prototype.getScale=function(){return this.style.getImage().getScale()},ol.Sprite.prototype.getBBox=function(t){var e=this.getCoordinate(),i=this.image.size*this.image.getScale()*t/2;return[e[0]-i,e[1]-i,e[0]+i,e[1]+i]},ol.Sprite.prototype.setState=function(t,e){return this.currentState=t,this.startState=e||(new Date).getTime(),this.dispatchEvent({type:"state",state:this.currentState,end:!1}),this.endState=!1,this.image.setState(this.currentState,0)},ol.Sprite.prototype.update=function(t){var e=this.image.setState(this.currentState,(t.frameState.time-this.startState)/this.frate);return e&&!this.endState&&(this.dispatchEvent({type:"state",state:this.currentState,end:!0}),this.endState=!0),e},ol.Sprite.prototype.setPath=function(t,e){null!=e&&(this.speed=e),t&&t.length&&(this.path=t,this.destination=1,this.moving_=!0,this.angle=Math.atan2(this.path[1][0]-this.path[0][0],this.path[1][1]-this.path[0][1]),this.dir=[Math.sin(this.angle),Math.cos(this.angle)],this.setCoordinate(this.path[0]),this.dispatchEvent({type:"change:direction",angle:this.angle}))},ol.Sprite.prototype.setDestination=function(t,e){this.setPath([this.getCoordinate(),t],e)},ol.Sprite.prototype.setDirection=function(t,e){this.destination=!1,this.moving_=!0,null!=e&&(this.speed=e),this.angle=t,this.dir=[Math.sin(this.angle),Math.cos(this.angle)],this.dispatchEvent({type:"change:direction",angle:this.angle})},ol.Sprite.prototype.getQuarter=function(){switch((Math.round(2*this.angle/Math.PI)+4)%4){case 0:return"N";case 1:return"E";case 2:return"S";case 3:return"W"}},ol.Sprite.prototype.moving=function(){return this.moving_},ol.Sprite.prototype.stop=function(){this.moving_=!1},ol.Sprite.prototype.restart=function(){this.moving_=!0},ol.Sprite.prototype.move=function(t){if(this.moving_){var e=this.getCoordinate(),i=[this.speed*this.dir[0]*t.dt,this.speed*this.dir[1]*t.dt];if(e[0]+=i[0],e[1]+=i[1],this.destination)if(Math.sign(this.path[this.destination][0]-e[0])!=Math.sign(this.dir[0])||Math.sign(this.path[this.destination][1]-e[1])!=Math.sign(this.dir[1]))if(this.destination++,this.destination>=this.path.length)this.stop(),this.setCoordinate(this.path[this.destination-1]),this.destination=0,this.dispatchEvent({type:"destination"});else{for(var o=ol.coordinate.dist2d(e,this.path[this.destination-1]);;){var s=ol.coordinate.dist2d(this.path[this.destination],this.path[this.destination-1]);if(s>o)break;if(o-=s,this.destination++,this.destination>=this.path.length)return this.stop(),this.setCoordinate(this.path[this.destination-1]),this.destination=0,void this.dispatchEvent({type:"destination"})}this.setCoordinate(this.path[this.destination-1]),this.angle=Math.atan2(this.path[this.destination][0]-this.path[this.destination-1][0],this.path[this.destination][1]-this.path[this.destination-1][1]),this.dir=[Math.sin(this.angle),Math.cos(this.angle)],this.dispatchEvent({type:"change:direction",angle:this.angle}),this.move({type:t.type,dt:o/this.speed,frameState:t.frameState})}else this.setCoordinate(e);else this.setCoordinate(e)}this.update(t)},ol.Sprite.prototype.setSpeed=function(t){this.speed=t},ol.Sprite.prototype.getSpeed=function(){return this.speed},ol.featureAnimation.Explode=function(t){t=t||{},ol.featureAnimation.call(this,t),this.radius=t.radius||50;var e=document.createElement("canvas");e.width=e.height=10;var i=e.getContext("2d"),o=this.gradient=i.createRadialGradient(0,0,0,0,0,this.radius);function s(t,e){return t*e/255|0}var a=ol.color.asArray(t.color||"#ebb"),n=a[0],r=a[1],h=a[2],l=a[3];o.addColorStop(0,"rgba("+[s(n,255),s(r,255),s(h,255),l]+")"),o.addColorStop(.3,"rgba("+[s(n,254),s(r,239),s(h,29),l]+")"),o.addColorStop(.4,"rgba("+[s(n,254),s(r,88),s(h,29),l]+")"),o.addColorStop(.6,"rgba("+[s(n,239),s(r,27),s(h,51),.05*l]+")"),o.addColorStop(.88,"rgba("+[s(n,153),s(r,10),s(h,27),.05*l]+")"),o.addColorStop(.92,"rgba("+[s(n,254),s(r,39),s(h,17),.1*l]+")"),o.addColorStop(.98,"rgba("+[s(n,254),s(r,254),s(h,183),.2*l]+")"),o.addColorStop(1,"rgba("+[s(n,254),s(r,39),s(h,17),0]+")");var p=t.dispersion||this.radius/2;this.particules=[{tmin:0,dt:1,radius:this.radius,x:0,y:0}];for(var g=t.length||12,c=0;c<g;c++)this.particules.push({tmin:.4*Math.random(),dt:.3+.3*Math.random(),radius:this.radius*(.5+.5*Math.random()),x:p*(Math.random()-.5),y:p*(Math.random()-.5)})},ol.ext.inherits(ol.featureAnimation.Explode,ol.featureAnimation),ol.featureAnimation.Explode.prototype.animate=function(t){var e=this.easing_(t.elapsed);if(e){t.context.save();var i,o,s=t.frameState.pixelRatio,a=t.frameState.coordinateToPixelTransform,n=a[0]*t.coord[0]+a[1]*t.coord[1]+a[4],r=a[2]*t.coord[0]+a[3]*t.coord[1]+a[5],h=t.inversePixelTransform;if(h){var l=[n*h[0]-r*h[1]+h[4],-n*h[2]+r*h[3]+h[5]];n=l[0],r=l[1],s=1}t.context.globalCompositeOperation="lighter",t.context.fillStyle=this.gradient,t.context.scale(s,s);for(var p,g=0;p=this.particules[g];g++)(i=(e-p.tmin)/p.dt)>0&&i<=1&&(t.context.save(),t.context.translate(n+p.x,r+p.y),o=i*p.radius/this.radius,t.context.scale(o,o),t.context.globalAlpha=1-i,t.context.fillRect(-p.radius,-p.radius,2*p.radius,2*p.radius),t.context.restore());t.context.restore()}return t.time<=this.duration_},ol.Backscreen=function(t){t=t||{},ol.Object.call(this);var e=this.element=document.createElement("div");e.style.position="relative",e.style.top=e.style.left="0px",e.style.top="-100%",e.style.width=t.map.getSize()[0]+"px",e.style.height=t.map.getSize()[1]+"px",e.style["z-index"]=0,e.className="ol-games-backscreen";var i=t.pixelRatio||window.devicePixelRatio;this.offmap=new ol.Map({target:e,pixelRatio:i,controls:[],interactions:[],layers:t.layers}),this.offmap.set("pixelRatio",i),this.setMap(t.map),this.image=this.offmap.getViewport().children[0],this.canvas=document.createElement("canvas")},ol.ext.inherits(ol.Backscreen,ol.Object),ol.Backscreen.prototype.setMap=function(t){this.map&&(this.map.getTargetElement().removeChild(this.element),this.offmap.setView(null)),this._listener&&ol.Observable.unByKey(this._listener),this._listener=null,this.map=t,this.map&&(this.map.getTargetElement().appendChild(this.element),this.map.getViewport().style["z-index"]||(this.map.getViewport().style["z-index"]=1),this._listener=this.map.on("change:size",this.changeSize_.bind(this)),this.offmap.setSize(this.map.getSize()),this.offmap.setView(this.map.getView()))},ol.Backscreen.prototype.getImage=function(){return this.image},ol.Backscreen.prototype.changeSize_=function(){this.element.style.width=this.map.getSize()[0]+"px",this.element.style.height=this.map.getSize()[1]+"px"},ol.Collision=function(t){ol.Object.call(this),this.game=t.game,this.resample=t.resample||1,this.canvas=document.createElement("canvas"),this.canvas.width=this.canvas.height=32,this.sprites=t.sprites||[],this.targets=t.targets||[]},ol.ext.inherits(ol.Collision,ol.Object),ol.Collision.prototype.getImage=function(){return this.canvas},ol.Collision.prototype.overflow=function(t){if(!this.game.frameState)return!1;var e=this.game.frameState.extent,i=t.getBBox(this.game.frameState.viewState.resolution);return e[0]>i[0]?"E":e[1]>i[1]?"N":e[2]<i[2]?"W":e[3]<i[3]&&"S"},ol.Collision.prototype.getPixel=function(t){var e=this.game.frameState.coordinateToPixelTransform;return[e[0]*t[0]+e[1]*t[1]+e[4],e[2]*t[0]+e[3]*t[1]+e[5]]},ol.Collision.prototype.dispatch=function(){if(this.game.frameState)for(var t=this.sprites.length,e=0;e<t-1;e++)for(var i=e+1;i<t;i++){var o=this.collide(this.sprites[e],this.sprites[i]);o&&(this.sprites[e].dispatchEvent({type:"collide",sprite:this.sprites[i],hit:o}),this.sprites[i].dispatchEvent({type:"collide",sprite:this.sprites[e],hit:o}))}},ol.Collision.prototype.collide=function(t,e){if(!this.game.frameState)return!1;var i=t.getBBox(this.game.frameState.viewState.resolution),o=e.getBBox(this.game.frameState.viewState.resolution);if(!ol.extent.intersects(i,o))return!1;var s=this.getPixel(i),a=this.getPixel(o),n=this.resample,r=Math.trunc(t.getImage().size*t.getImage().getScale()/n),h=this.canvas;h.width=h.height=r;var l=h.getContext("2d");l.save(),l.globalCompositeOperation="copy",l.fillStyle="#FFF",l.fillRect(0,0,r,r),l.globalCompositeOperation="destination-out",l.drawImage(t.getImage().getImage(),0,0,t.getImage().size,t.getImage().size,0,0,r,r),l.globalCompositeOperation="source-out",l.translate((a[0]-s[0])/n,(a[1]-s[1])/n),l.drawImage(e.getImage().getImage(),0,0,e.getImage().size,e.getImage().size,0,0,r,r),l.restore();for(var p=l.getImageData(0,0,r,r),g=3;g<p.data.length;g+=4)if(p.data[g]>0){var c=g/4/r|0;return[(g/4-c*r|0)*n,c*n]}},ol.Game=function(t){t=t||{},ol.Object.call(this);var e=t.map||new ol.Map({target:t.target,loadTilesWhileAnimating:!0,loadTilesWhileInteracting:!0,view:new ol.View({zoom:t.zoom,center:t.center}),interactions:[],controls:[],layers:t.layers});if(t.controls)for(var i=0;i<t.controls.length;i++)e.addControl(t.controls[i]);this.setMap(e),this.pause_=!0,this.collisions=[],this.collision=new ol.Collision({game:this,resample:t.collisionResample})},ol.ext.inherits(ol.Game,ol.Object),ol.Game.prototype.setMap=function(t){this._listener&&ol.Observable.unByKey(this._listener),this._listener=null,this.map=t,this.map&&(this._listener=this.map.on("postcompose",this.anim_.bind(this)))},ol.Game.prototype.getMap=function(){return this.map},ol.Game.prototype.getView=function(){return this.map.getView()},ol.Game.prototype.addControl=function(t){return this.map.addControl(t)},ol.Game.prototype.collide=function(t,e){return this.collision.collide(t,e)},ol.Game.prototype.start=function(){this.time=(new Date).getTime(),this.pause_=!1,this.map.render(),this.dispatchEvent({type:"start"})},ol.Game.prototype.pause=function(){this.pause_=!0,this.dispatchEvent({type:"pause"})},ol.Game.prototype.paused=function(){return this.pause_},ol.Game.prototype.addCollision=function(t){t instanceof Array||(t=[t]),this.collisions=this.collisions.concat(t)},ol.Game.prototype.anim_=function(t){if(t.dt=t.frameState.time-this.time,this.time=t.frameState.time,this.frameState=t.frameState,!this.pause_){for(var e=this.collisions.length-1;e>=0;e--)this.collisions[e].dispatch();this.dispatchEvent({type:"render",context:t.context,dt:t.dt,frameState:t.frameState,vectorContext:t.vectorContext}),this.map.render()}},ol.Game.prototype.timer=function(t){this._time&&!0!==t?console.log("[TIMER] "+(new Date-this._time)+" : "+(t||"timer")):console.log("[TIMER] start"),this._time=new Date},ol.Offscreen=function(t){t=t||{},ol.Object.call(this);var e=this.element=document.createElement("div");e.style.position="absolute",e.style.opacity=0,e.style.visibility="hidden",e.style.top=e.style.left="-100000px",e.style.width=t.map.getSize()[0]+"px",e.style.height=t.map.getSize()[1]+"px",e.className="ol-games-offscreen";var i=t.pixelRatio||1;this.offmap=new ol.Map({target:e,pixelRatio:i,controls:[],interactions:[],layers:t.layers}),this.offmap.set("pixelRatio",i),this.setMap(t.map),this.resample=t.resample||1,this.canvas=document.createElement("canvas"),this.canvas.width=this.canvas.height=32},ol.ext.inherits(ol.Offscreen,ol.Object),ol.Offscreen.prototype.setMap=function(t){this.map&&(this.map.getViewport().removeChild(this.element),this.offmap.setView(null)),this._listener&&ol.Observable.unByKey(this._listener),this._listener=null,this.map=t,this.map&&(this.map.getViewport().appendChild(this.element),this._listener=this.map.on("change:size",this.changeSize_.bind(this)),this.offmap.setSize(this.map.getSize()),this.offmap.setView(this.map.getView()))},ol.Offscreen.prototype.getImage=function(){var t=this.offmap.getViewport().querySelector("canvas");return t||(t=document.createElement("CANVAS")),t},ol.Offscreen.prototype.changeSize_=function(){this.element.style.width=this.map.getSize()[0]+"px",this.element.style.height=this.map.getSize()[1]+"px"},ol.Offscreen.prototype.getPixelValue=function(t){var e=null;return this.offmap.forEachLayerAtPixel(t,function(t,i){if(t&&i)return e=i,!0}),e},ol.Offscreen.prototype.getValue=function(t){return this.getPixelValue(this.offmap.getPixelFromCoordinate(t))},ol.Offscreen.prototype.collide=function(t){var e=this.offmap.get("pixelRatio"),i=t.getBBox(this.map.getView().getResolution()),o=this.map.getView().calculateExtent(this.map.getSize());if(!ol.extent.intersects(i,o))return!1;var s=this.map.getPixelFromCoordinate(i);if(!s)return!1;var a=this.resample,n=Math.trunc(t.getImage().size*t.getImage().getScale()/a),r=n*a*e,h=this.canvas;h.width!=n&&(h.width=h.height=n);var l=h.getContext("2d");l.save(),l.globalCompositeOperation="copy",l.fillStyle="#FFF",l.fillRect(0,0,n,n),l.globalCompositeOperation="destination-out",l.drawImage(t.getImage().getImage(),0,0,t.getImage().size,t.getImage().size,0,0,n,n),l.globalCompositeOperation="source-out",l.drawImage(this.getImage(),s[0]*e,s[1]*e-r,r,r,0,0,n,n),l.restore();for(var p=l.getImageData(0,0,n,n),g=3;g<p.data.length;g+=4)if(p.data[g]>0){var c=g/4/n|0;return[(g/4-c*n|0)*a,c*a]}return!1},ol.graph.Vector=function(t){t=t||{},ol.Object.call(this,t),this.edges=t.source||new ol.source.Vector({useSpatialIndex:!0}),this.edges.on("changefeature",this.changeEdge.bind(this)),this.edges.on("addfeature",this.addEdge.bind(this)),this.edges.on("removefeature",this.removeEdge.bind(this))},ol.ext.inherits(ol.graph.Vector,ol.Object),ol.graph.Vector.prototype.getSource=function(){return this.edges},ol.graph.Vector.prototype.changeEdge=function(){},ol.graph.Vector.prototype.addEdge=function(){},ol.graph.Vector.prototype.removeEdge=function(){},ol.graph.Vector.prototype.getConnections=function(t,e,i){for(var o,s=t.getCoordinates?t.getCoordinates():t,a=this.edges.getFeaturesInExtent([s[0]-1,s[1]-1,s[0]+1,s[1]+1]),n=e?{in:[],out:[]}:[],r=0;o=a[r];r++)i&&!i(o)||(ol.coordinate.equal(s,o.getGeometry().getFirstCoordinate())?e?n.out.push(o):n.push(o):ol.coordinate.equal(s,o.getGeometry().getLastCoordinate())&&(e?n.in.push(o):n.push(o)));return n},ol.graph.Vector.prototype.getConnected=function(t,e){var i=[],o=function(e){return e===t};return i[0]=this.getConnections(t.getGeometry().getFirstCoordinate(),e,o),i[1]=this.getConnections(t.getGeometry().getLastCoordinate(),e,o),i},ol.graph.Vector.prototype.filterEdge=function(t){return"LineString"===t.getGeometry().getType()},ol.graph.Vector.prototype.isEdge=function(t){return"LineString"!==t.getGeometry().getType()},ol.graph.Vector.prototype.getNN=function(t,e){var i;if(e){var o=this.edges.getFeaturesInExtent([t[0]-e,t[1]-e,t[0]+e,t[1]+e]),s=1/0;o.forEach(function(e){var o=e.getGeometry().getClosestPoint(t),a=ol.coordinate.dist2d(o,t);a<s&&(s=a,i=e)}),s>e&&(i=null)}else for(var a=1;a<1e10&&!(i=this.getNN(t,a));a*=10);return i},ol.media={},ol.media.Media=function(t){t=t||{};var e=this;for(var i in ol.Object.call(this),this.media=t.media,t.loop&&this.setLoop(t.loop),this.media.addEventListener("canplaythrough",function(){e.dispatchEvent({type:"ready"})},!1),{load:1,play:1,pause:1,ended:1})this.media.addEventListener(i,function(t){e.dispatchEvent({type:t.type})})},ol.ext.inherits(ol.media.Media,ol.Object),ol.media.Media.prototype.play=function(t){void 0!==t&&(this.media.pause(),this.media.currentTime=t);var e=this.media.play();void 0!==e&&e.then(function(){}).catch(function(){console.log("Unable to play soud... Let a UI element start before play...")})},ol.media.Media.prototype.pause=function(){this.media.pause()},ol.media.Media.prototype.stop=function(){this.media.pause(),this.media.currentTime=0},ol.media.Media.prototype.setVolume=function(t){this.media.volume=t},ol.media.Media.prototype.getVolume=function(){return this.media.volume},ol.media.Media.prototype.mute=function(t){this.media.muted=t||!1===t?t:!this.media.muted},ol.media.Media.prototype.isMuted=function(){return this.media.muted},ol.media.Media.prototype.getTime=function(t){this.media.prop("currentTime",t)},ol.media.Media.prototype.getTime=function(){return this.media.prop("currentTime")},ol.media.Media.prototype.getDuration=function(){return this.media.prop("duration")},ol.media.Media.prototype.getDuration=function(){return Math.floor(this.media.prop("duration")/60)+":"+Math.floor(this.media.prop("duration")-60*Math.floor(this.media.prop("duration")/60))},ol.media.Media.prototype.setLoop=function(t){this.media.loop=t},ol.media.Media.prototype.getLoop=function(){return this.media.loop},ol.media.Audio=function(t){t=t||{};var e=new Audio(t.source);e.load(),ol.media.Media.call(this,{media:e,loop:t.loop})},ol.ext.inherits(ol.media.Audio,ol.media.Media),ol.source.HexMap=function(t){t=t||{},this.canvas=document.createElement("canvas"),this.context=this.canvas.getContext("2d"),this.grid=t.hexGrid,this.grid.on("change",this.changed.bind(this)),ol.source.ImageCanvas.call(this,{canvasFunction:this.drawHex})},ol.ext.inherits(ol.source.HexMap,ol.source.ImageCanvas),ol.source.HexMap.prototype.drawHexagon=function(t,e,i,o,s,a,n){var r;t.beginPath(),a=a||6,n=n||0;for(var h=s=s||0;h<=a;h++)r=this.grid.hex_corner(e,i-n,h),h!=s?t.lineTo(r[0],r[1]):t.moveTo(r[0],r[1]);t.stroke(),o&&t.fill()},ol.source.HexMap.prototype.showCoordiantes=function(t){this.coordinates_=t,this.changed()},ol.source.HexMap.prototype.drawHex=function(t,e,i,o){var s,a,n,r,h,l=this.canvas.width=o[0],p=this.canvas.height=o[1];this.extent=t;var g=this.grid.getSize()/e;if(g<8){var c=document.createElement("canvas");s=c.getContext("2d");var d=2*Math.sqrt(3)*g*i*10,m=3*g*i*10;c.width=Math.round(d),c.height=Math.round(m),s.scale(i,i),s.lineWidth=1.5,s.fillStyle="transparent";var u=this.grid.coord2hex([t[0],t[3]]);for(a=-10;a<22;a++)for(n=-3;n<22;n++)(r=this.grid.hex2coord([u[0]+a,u[1]+n]))[0]=(r[0]-t[0])/e,r[1]=c.height-(r[1]-t[3])/e,s.strokeStyle="rgba(0,0,0,0.5)",this.drawHexagon(s,r,g,0,3),s.strokeStyle="rgba(255,255,255,0.8)",this.drawHexagon(s,r,g,!1,2,5,2),s.strokeStyle="rgba(0,0,0,0.3)",this.drawHexagon(s,r,g,!1,5,8,2);var f=document.createElement("canvas");s=f.getContext("2d"),f.width=Math.round(l+(d-c.width)*Math.floor(l/c.width)),f.height=Math.round(p+(m-c.height)*Math.floor(p/c.height)),s.fillStyle=s.createPattern(c,"repeat"),s.fillRect(0,0,f.width,f.height),this.context.drawImage(f,0,0,l,p,0,0,f.width,f.height)}else{(s=this.context).save();var y=this.grid.hex2offset(this.grid.coord2hex([t[0],t[1]])),v=this.grid.hex2offset(this.grid.coord2hex([t[2],t[3]]));for(s.scale(i,i),s.lineWidth=1.5,s.textAlign="center",s.textBaseline="middle",s.font="bold 12px Arial",a=y[0]-1;a<=v[0]+1;a++)for(n=y[1]-1;n<=v[1]+1;n++){var S=this.grid.offset2hex([a,n],this.layout_);if((r=this.grid.hex2coord(S))[0]=(r[0]-t[0])/e,r[1]=p/i-(r[1]-t[1])/e,s.strokeStyle="rgba(0,0,0,0.25)",this.drawHexagon(s,r,g),s.strokeStyle="rgba(255,255,255,0.8)",this.drawHexagon(s,r,g,!1,2,5,2),s.strokeStyle="rgba(0,0,0,0.3)",this.drawHexagon(s,r,g,!1,5,8,2),g>20)switch(this.coordinates_){case"axial":s.fillText(S[0]+","+S[1],r[0],r[1]);break;case"cube":h=this.grid.hex2cube(S);for(var x=0;x<3;x++){var C=-Math.PI/180*(120*x+30);s.fillText(h[x],r[0]+Math.cos(C)*g*.5,r[1]+Math.sin(C)*g*.5)}break;case"offset":h=this.grid.hex2offset(S),s.fillText(h[0]+","+h[1],r[0],r[1])}}s.restore()}return this.canvas},ol.style.Sprite=function(t){t=t||{};var e=document.createElement("canvas");this.size=e.width=e.height=t.size||64,ol.style.Icon.call(this,{img:e,imgSize:[this.size,this.size],scale:t.scale}),this.offset=[0,0];var i,o=this;t.img?i=this.img_=t.img:((i=this.img_=new Image).crossOrigin=t.crossOrigin||"anonymous",i.src=t.src),t.states&&(this.states=t.states),i.width?this.drawImage_():i.onload=function(){o.drawImage_()}},ol.ext.inherits(ol.style.Sprite,ol.style.Icon),ol.style.Sprite.prototype.drawImage_=function(){var t=this.getImage().getContext("2d");t.clearRect(0,0,this.size,this.size),t.drawImage(this.img_,this.offset[0],this.offset[1],this.size,this.size,0,0,this.size,this.size)},ol.style.Sprite.prototype.states={idle:{line:2,length:1},encant_N:{line:0,length:7},encant_W:{line:1,length:7},encant_S:{line:2,length:7},encant_E:{line:3,length:7},thrust_N:{line:4,length:8},thrust_W:{line:5,length:8},thrust_S:{line:6,length:8},thrust_E:{line:7,length:8},walk_N:{line:8,start:1,length:8},walk_W:{line:9,start:1,length:8},walk_S:{line:10,start:1,length:8},walk_E:{line:11,start:1,length:8},slash_N:{line:12,length:6},slash_W:{line:13,length:6},slash_S:{line:14,length:6},slash_E:{line:15,length:6},shoot_N:{line:16,length:13},shoot_W:{line:17,length:13},shoot_S:{line:18,length:13},shoot_E:{line:19,length:13},hurt:{line:20,length:6}},ol.style.Sprite.prototype.setState=function(t,e){var i=this.states[t]||{},o=[((i.start||0)+Math.trunc(e)%i.length)*(i.size||this.size),(i.line||0)*(i.size||this.size)];return o[0]==this.offset[0]&&o[1]==this.offset[1]||(this.offset=o,this.drawImage_()),e+1>=i.length},ol.style.Sprite.prototype.setAnchor=function(t){var e=this.getAnchor();e[0]=t[0]*this.size,e[1]=t[1]*this.size},ol.coordinate.projLineRef=function(t,e){var i=t[0]-e[0][0],o=t[1]-e[0][1],s=e[1][0]-e[0][0],a=e[1][1]-e[0][1],n=s*s+a*a;return 0!=n?(i*s+o*a)/n:0},ol.coordinate.projLine=function(t,e){var i=ol.coordinate.projLineRef(t,e);return[e[0][0]+i*(e[1][0]-e[0][0]),e[0][1]+i*(e[1][1]-e[0][1])]},ol.coordinate.projSeg=function(t,e){var i=ol.coordinate.projLineRef(t,e);return i<=0?e[0]:i>=1?e[1]:[e[0][0]+i*(e[1][0]-e[0][0]),e[0][1]+i*(e[1][1]-e[0][1])]},ol.coordinate.revers=function(t){for(var e=[],i=-1;i>=0;i--)e.push(t[i])},ol.geom.LineString.prototype.getCoordinateAtRef=function(t,e){var i,o;if(t<1e-10)return e&&(i=this.getCoordinates(),e[0]=i[0],e[1]=i[1]),this.getFirstCoordinate();if(this.getLength()-t<1e-10)return e&&(i=this.getCoordinates(),e[0]=i[i.length-2],e[1]=i[i.length-1]),this.getLastCoordinate();e||(e=[]);for(var s=0,a=this.getCoordinates(),n=1;n<a.length;n++){if(s+(o=ol.coordinate.dist2d(a[n-1],a[n]))>=t){var r=e[0]=a[n-1],h=e[1]=a[n];return o=ol.coordinate.dist2d(r,h),[r[0]+(t-s)*(h[0]-r[0])/o,r[1]+(t-s)*(h[1]-r[1])/o]}s+=o}},ol.geom.LineString.prototype.lineRef=function(t){for(var e,i,o,s=this.getCoordinates(),a=0,n=1;n<s.length;n++)if(e=s[n-1],i=s[n],(o=ol.coordinate.projLineRef(t,[e,i]))>=0&&o<=1){var r=[e[0]+o*(i[0]-e[0]),e[1]+o*(i[1]-e[1])];if(ol.coordinate.dist2d(t,r)<1e-10)return a+o*ol.coordinate.dist2d(e,i)}else a+=ol.coordinate.dist2d(e,i);return!1},ol.geom.LineString.prototype.sample=function(t,e){e=e||{};var i,o,s,a,n,r=this.getCoordinates(),h=[],l=0,p=0,g=this.getLength();if(g<(e.minLength||0))return[];e.distribute&&(t=(g=this.getLength())>t?g/(g/t|0):g),e.center?(l=g-t*(g/t|0))<1e-10?g>t?l=-t/2:(t=g,l=-g/2):l=l/2-t:h.push(r[0]);for(var c=1;c<r.length;c++){i=r[c-1],o=r[c],n=ol.coordinate.dist2d(i,o);for(var d=t+l-p;d<n;d+=t)s=d/n,a=[i[0]+(o[0]-i[0])*s,i[1]+(o[1]-i[1])*s],h.push(a),l+=t;p+=n}return h};